#if 1
#include <Base/TMatrix.h>
#include <Base/TinyVec.h>
#include <iostream>


using namespace PTM;
using namespace Spr;
using namespace std;
void main(){
	TMatrixCol<3,3,float> m33;
    TMatrixRow<3,3,float> work_around_for_bcb;
	m33.row(0) = Vec3f(1,2,3);
	m33.row(1) = Vec3f(10,20,30)*2;
	m33.row(2) = Vec3f(100,200,300)*3;
	cout << m33;
	cout << m33.trans();
	m33 = m33.trans();
	cout << m33;
	cout << endl;
	
	TMatrixCol<6,6,float> m66;
	int v=1;
	for(unsigned i=0; i<6; ++i){
		for(unsigned j=0; j<6; ++j){
			m66.item(i,j) = (float)v++;
		}
	}
	cout << m66;
	typedef TSubMatrixCol<4,4,TMatrixCol<6,6,float>::desc> Sub;
	Sub& sm = m66.sub_matrix(1,2,Sub());
	cout << sm;
    Sub::desc::trans_type smt = sm.trans();
	cout << sm.trans();
	typedef TSubMatrixCol<2,2,Sub::desc> SubSub;
	SubSub&ssm = sm.sub_matrix(1,1,SubSub());
	cout << ssm;
    SubSub::desc::trans_type ssmt = ssm.trans();
	cout << ssm.trans();

	typedef ESubMatrixCol<float> ESub;
	ESub esm = m66.vsub_matrix(1,2,4,4);
	TMatrixCol<6,6,float>::desc::row_vector_type rrow = m66.row(1);
	cout << esm;
	cout << esm.trans();
	typedef ESubMatrixCol<float> ESubSub;
	ESubSub essm = esm.vsub_matrix(1,1,2,2);
	cout << essm;
	cout << essm.trans();
}


#else


#include <Base/TMatrixColUtility.h>

#include <iostream>
#include <sstream>
using namespace PTM;
using namespace std;

template <class A, class B>
void test(A& a, B& b){
	a = b;
	assert(b == a);
	assert(b*2 == a+a);
	assert(b*0 == a-a);
	cout << a;
}
template <class M>
void initMat(M& a){
	size_t v=0;
	for(size_t i=0; i<a.height(); ++i){
		for(size_t j=0; j<a.width(); ++j){
			a.item(i,j) = ++v;
		}
	}
}

int main(){
	VMatrix<float> va;
	VMatrix<float> vb;
	va.resize(4,4);
	vb.resize(4,4);
	initMat(va);
	initMat(vb);
	test(va.sub_matrix(1,1,3,3), vb.sub_matrix(1,1,3,3));
	test(va.sub_matrix(1,1,3,3).sub_matrix(1,1,2,2), vb.sub_matrix(1,1,3,3).sub_matrix(1,1,2,2));
	test(va.trans(), vb.trans());
	test(va.trans().sub_matrix(1,1,3,3), vb.trans().sub_matrix(1,1,3,3));
	test(va.trans().sub_matrix(1,1,3,3).sub_matrix(1,1,2,2), vb.trans().sub_matrix(1,1,3,3).sub_matrix(1,1,2,2));
	test(va, vb);

	TMatrixCol<4,4,float> ta;
	TMatrixCol<4,4,float> tb;
	initMat(ta);
	initMat(tb);
	test(ta, tb);
	
#if 0
	TVector<2, float> a;
	TVector<4, float> b;
	TMatrixCol<4,2, float> matA;
	TMatrixCol<2,5, float> matB;
	for(int i=0; i<a.size(); ++i) a[i] = i+1;
	for(int i=0; i<b.size(); ++i) b[i] = i+1;
	for(int i=0; i<matA.height(); ++i){
		for(int j=0; j<matA.width(); ++j) matA[i][j] = 10*i+j;
	}
	for(int i=0; i<matB.height(); ++i){
		for(int j=0; j<matB.width(); ++j) matB[i][j] = 10*i+j;
	}
	cout << matA << "*" << a << "=" << matA * a << endl << endl;
	cout << matA.trans() << endl << endl;
	a = b * matA;
	cout << a << endl << endl;
	cout << matA << " * " << endl;
	cout << matB << " = " << endl;
	cout << matA * matB;

	TSubMatrixCol<2,0,2,2,	TMatrixCol<4,2, float>::buf_type> s;
	s = matA.sub_matrix(s);
	cout << matA.sub_matrix(s);
	cout << s;
#endif

	return 0;
	//	Zq̃eXg
}



#endif
