#ifndef CDPOLYHEDRON_H
#define CDPOLYHEDRON_H
#include "CDGeometry.h"
#include "CDConvex.h"
#include "CDQuickHull3D.h"
#include <Physics/PHPhysicalMaterial.h>

namespace Spr {;

class CDPolyhedron;
class CDFace{
public:
	class DualPlanes: public std::vector<CDQHPlane<CDFace>*>{
	public:
	};
	int vtxs[3];	///< ʂ̒_

	//	̌`߂vẐ߂̍Ɨ̈
	Vec3f normal;	///<	ʂ̖@xNg
	float dist;		///<	_̋
	///	QuickHullɂƂĂ̒_D̖ʂoΕϊĂł钸_
	Vec3f GetPos() const { return normal / dist; }
	///
	/**	QuickHullASYp[NGAD
		ԉ_猩ʂ폜Ǝc`̃GbW
		ڑĂ߂̃|C^D
		_ʂ̐ڑD	ʁ_͒_̕я番D	*/
	CDQHPlane<CDFace>* horizon;

	/**	oΕϊsDbaseɓn_obt@́CoΕϊ\Ȃ悤
		oΕϊ̒S_ƂȂ悤ȍWnłȂ΂ȂȂD	*/
	bool CalcDualVtx(Vec3f* base);

	/**	̖ʂoΕϊĂł钸_܂ޖʁD
		܂Č`\钸_̂C
		̖ʂɂ	*/
	DualPlanes dualPlanes;
	///	̌`\钸_̖̂ʂɂ̂̐.
	size_t NCommonVtx(){ return dualPlanes.size(); }
	///	̌`\钸_̖̂ʂɂ.
	Vec3f CommonVtx(int i);
	///	fobOp\
	void Print(std::ostream& os) const;
};
inline std::ostream& operator << (std::ostream& os, const CDFace& f){
	f.Print(os);
	return os;
}
class CDFaces:public std::vector<CDFace>{
};
class CDVertexIDs:public std::vector<int>{
public:
	int FindPos(int id) const;
};

/**	3p`\ʑʑ	*/
class CDPolyhedron:public CDConvex{
public:
	SGOBJECTDEF(CDPolyhedron);
	///	TJn_ԍ
	mutable int curPos;
	///	GeomtryID
	virtual int GeometryID(){ return CONVEX; }
	///	_̍W([JWn)
	Vec3f* base;
	///	Ɨ̈F_̍W(ϊ̍Wn)
	Vec3f* tvtxs;

	///	̓ʑʑ̂\钸_Dpos͂̔z̈ʒu\D
	CDVertexIDs vtxIDs;
	///	_ׂ̗̒_̈ʒuz
	std::vector< std::vector<int> > neighbor;
	///	(3p`)
	CDFaces faces;

	///	_̍WԂD
	Vec3f Vertex(int pos) const { return base[vtxIDs[pos]]; }

	///	_ʂڑ𐶐D
	void CalcFace();
	///	ꕽʏŐڑĂ3p`}[W
	void MergeFace();
	
	///	ʂĂ邩ǂׂ
	bool HasFace(CDFace* face){
		return &*faces.begin() <= face && face <= &*faces.end();
	}
	///	T|[g|Cg߂D
	virtual Vec3f Support(const Vec3f& p) const;
private:
	bool VertexNear(int v1, int v2) const;
};

}
#endif
