#ifndef FIDOCSCENE_H
#define FIDOCSCENE_H
#include "FIDocNode.h"
#include "FIFileDoc.h"
#include "FITypeDesc.h"
#include <SceneGraph/SGScene.h>

/**	@file FIDocScene.h hLgV[Ot[hdg	*/
namespace Spr{;

/**	^̃hLgm[h̃[_[	*/
class SPR_DLL FIBaseLoader:public UTRefCount{
public:
	///	[_S^
	virtual UTString GetNodeType() const =0;
	///	[h֐Dqm[h[hOɌĂ΂D
	virtual void Load(class FILoadScene* context)=0;
	///	[h㏈֐Dqm[h[hꂽĂ΂D
	virtual void Loaded(class FILoadScene* context){}
};
template <class T, bool bAdd=true, bool bCont=true> class FIObjectLoader: public FIBaseLoader{
public:
	typedef T TLoaded;
	void Create(class FILoadScene* context, UTRef<TLoaded>& t){
		t = new TLoaded;
		t->SetName(context->docs.Top()->GetName().c_str(), context->scene);
	}
	///	[_Sm[ȟ^DC++NX̌^ړ2Ȃ́D
	virtual UTString GetNodeType() const{
		return TLoaded::GetTypeInfoStatic()->ClassName()+2;
	}
	///	[h֐Dqm[h[hOɌĂ΂D
	virtual void Load(class FILoadScene* context){
		UTRef<TLoaded> t=NULL;
		Create(context, t);
		t->doc = context->docs.Top();
		t->SetName(t->doc->GetName().c_str(), context->scene);
		if (bAdd) context->AddObject(t);
		if (bCont) context->AddContainer(t);
		if (!LoadData(context, t)){
			if (bAdd){
				context->CancelAddObject();
			}
		}
	}
	///	[h̎
	virtual bool LoadData(class FILoadScene* context, TLoaded* t)=0;
};

template <class P=SGFrame> class FIOtherLoader: public FIBaseLoader{
public:
	///	[h֐Dqm[h[hOɌĂ΂D
	virtual void Load(class FILoadScene* context){
		P* p=NULL;
		context->objects.Find(p);
		Load(context, p);
	}
	virtual void Load(class FILoadScene* context, P* p)=0;
	///	[h㏈֐Dqm[h[hꂽĂ΂D
};

inline bool operator < (const FIBaseLoader& t1, const FIBaseLoader& t2){
	return t1.GetNodeType().compare(t2.GetNodeType()) < 0;
}
///	em[h̃[_[Set
class SPR_DLL FILoders:public std::multiset<FIBaseLoader*, UTContentsLess<FIBaseLoader*> >{
public:
	class FITypeLoaderKey:public FIBaseLoader{
		UTString* key;
	public:
		FITypeLoaderKey(UTString& k):key(&k){}
		virtual UTString GetNodeType() const{ return *key; }
		virtual void Load(FILoadScene* context){}
	};
	iterator LowerBound(UTString s){
		return lower_bound(&FITypeLoaderKey(s));
	}
	iterator UpperBound(UTString s){
		return upper_bound(&FITypeLoaderKey(s));
	}
	std::pair<iterator, iterator> EqualRange(UTString s){
		return equal_range(&FITypeLoaderKey(s));
	}
	void Erase(UTString s){
		std::pair<iterator, iterator> r = EqualRange(s);
		erase(r.first, r.second);
	}
};

class SPR_DLL FIReferenceBase:public UTRefCount{
protected:
	SGObject* Find(SGScene* s);
	///	t@X̖O
	UTString name;
public:
	virtual ~FIReferenceBase(){}
	///	QƂ̉
	virtual void SolveReference(SGScene* s)=0;
};
class SPR_DLL FIReferences:public std::vector< UTRef<FIReferenceBase> >{
};
/**	t@XێNX	*/
template <class T>
class SPR_DLL FIReference:public FIReferenceBase{
	///	t@X|C^̃AhXDD
	UTRef<T>* reference;
	///	
public:
	FIReference(UTRef<T>& t, UTString n): reference(&t) { name=n; }
	///	QƂ̉
	virtual void SolveReference(SGScene* s){
		T* t = (T*)Find(s);
		*reference = t;
//		reference->ForceOverWrite(t);
//		t->AddRef();
	}
};
template <class CT>
class SPR_DLL FIReferenceVector:public FIReferenceBase{
	///	t@X|C^̃AhXDD
	CT* container;
	typedef TYPENAME CT::value_type T;
	int pos;
public:
	FIReferenceVector(CT& c, int p, UTString n): container(&c), pos(p) { name=n; }
	///	QƂ̉
	virtual void SolveReference(SGScene* s){
		T t = T(UTRef<SGObject>(Find(s)));
		(*container)[pos] = t;
	}
};
template <class T>
FIReference<T>* createFIReference(UTRef<T>& t, UTString n){
	return new FIReference<T>(t, n);
}
template <class CT>
FIReferenceVector<CT>* createFIReference(CT& ct, int p, UTString n){
	return new FIReferenceVector<CT>(ct, p, n);
}

class SPR_DLL FILink: public SGObject{
public:
	SGOBJECTDEF(FILink);
	UTString linkName;
};
class SGObject;
class SPR_DLL FIObjectAdder{
public:
	///	ǉ̃IuWFNg
	SGObjects containers;
	///	ǉIuWFNg
	SGObjects objects;
	///	QƂ
	void Link(SGScene* scene);
	void Add(SGObject* obj);
	void Add(UTString name);
};
class SPR_DLL FIObjectAdders:public UTStack<FIObjectAdder>{
public:
};

/**	hLgm[h̃c[ǂŃV[OtD
	ReLXgێD
	hLgm[hɂ́C^^ƂɃ[_pӂłD
	^Ƃ̃[_[FIBaseLoaderhčD
*/
class SPR_DLL FILoadScene:public UTRefCount{
	///	^Ƃ̃[_[
	FILoders loaders;
	/**	IuWFNg̒ǉXgiQƉɒǉj
		ǉׂReirő邱Ƃ̂ŁC
		܂adderStackɓĂCɈڂD*/
	FIObjectAdders adders;
	/**	IuWFNg̒ǉXg̃X^bNDm[hƂPush,PopD
		ЂƂ̃m[h̃[_ꍇC[hɃRei邱ƂD
		ŁC[h̒ǉXgƁC[h̃ReiЂƂ܂ɓĂD
		PopƂɁCǉXgadders ɈڂD*/
	FIObjectAdders adderStack;
	///	qm[ĥ߂̃ReiXg
	SGObjects containers;
public:
	///	@name em[h̃[_go
	//@{
	///	Ƃ̃t@C
	UTString fileName;
	///	[h̃hLg̃X^bN
	FIDocNodes docs;
	///	[hV[
	UTRef<SGScene> scene;
	///	[hɎgIuWFNg̃X^bN
	SGObjects objects;
	///	[hIuWFNg݂̃Reiɒǉ
	void AddObject(SGObject* obj);
	///	[ht@X݂̃Reiɒǉ
	void AddObject(UTString name);
	///	Ō̒ǉLZ
	void CancelAddObject();
	///	Reiǉ
	void AddContainer(SGObject* cont){
		containers.Push(cont);
	}
	///	ReiX^bNPushDtrueԂD
	bool PushContainer();
	///	ReiX^bNPop
	void PopContainer();
	//@}

	//@name	OĂяo֐D
	//@{
	///	hLgIuWFNgV[Ot쐬
	virtual void Load(SGScene* s, SGObject* obj, FIFileDoc* fileDoc);
	virtual void Load(SGScene* s, FIFileDoc* fileDoc);
	virtual void Load(SGScene* s, SGObject* obj, FIDocNodes& docs);
	virtual void Load(SGScene* s, FIDocNodes& docs);
	///	[_[o^
	void Register(FIBaseLoader* l){ loaders.insert(l); }
	///	[_[폜
	void Erase(UTString k){ loaders.Erase(k); }
	///	hLgIuWFNgV[Ot쐬
	virtual void LoadRecursive();
	//@}


protected:
	///	QƂ̉D
	void SolveReferences();
	///	IuWFNg̒ǉD
	void AddObjects();
};

///	^(SGFrame/Visual/..) ۑZ[o[
class FIBaseSaver:public UTRefCount{
public:
	virtual UTString GetType() const =0;
	virtual UTString GetNodeType() const { return GetType().substr(2); }
	virtual void Save(class FISaveScene* ctx, SGObject* target){}
};
inline bool operator < (const FIBaseSaver& t1, const FIBaseSaver& t2){
	return t1.GetType().compare(t2.GetType()) < 0;
}
///	SGObject̂߂̃Z[o[
template <class T, bool bAdd=true, bool bCont=true> class FIObjectSaver: public FIBaseSaver{
public:
	typedef T TSaved;
	///	^
	virtual UTString GetType() const {
		return TSaved::GetTypeInfoStatic()->ClassName();
	}
	///	f[^̃Z[uDI[o[ChĂD
	virtual void SaveData(class FISaveScene* ctx, FIDocNodeBase* doc, TSaved* target)=0;
	///	Z[u
	virtual void Save(class FISaveScene* ctx, SGObject* target){
		TSaved* t = (TSaved*) target;
		UTRef<FIDocNodeBase> doc = t->doc;
		if (!doc) doc = ctx->CreateDocNode(GetNodeType(), t);
        doc->SetName(target->GetName());
		doc->ClearChildren();
		SaveData(ctx, doc, t);
		if (bAdd) ctx->docs.Top()->AddChild(doc);
		if (bCont){
			ctx->docs.Push(doc);
			for(unsigned i=0; i<t->NChildObjects(); ++i){
				ctx->SaveRecursive(t->ChildObject(i));
			}
			for(unsigned i=0; i<t->NReferenceObjects(); ++i){
				ctx->SaveReference(t->ReferenceObject(i));
			}
			ctx->docs.Pop();
		}
	}
};

///	^(SGFrame/Visual/..) ۑZ[o[Set
class FISavers:public std::set<FIBaseSaver*, UTContentsLess<FIBaseSaver*> >{
public:
	class FITypeSaverKey:public FIBaseSaver{
		UTString* key;
	public:
		FITypeSaverKey(UTString& k):key(&k){}
		virtual UTString GetType() const{ return *key; }
		virtual void Save(FISaveScene* context, SGObject* target){}
	};
	iterator Find(UTString s){
		return find(&FITypeSaverKey(s));
	}
};
/**	V[OthLgɃZ[uZ[o[
*/
class SPR_DLL FISaveScene:public UTRefCount{
protected:
	///	^Ƃ̃Z[o[
	FISavers savers;
	///	hLgm[h̐
	virtual UTRef<FIDocNodeBase> CreateDocNodeImp(UTString type)=0;
public:
	///	Z[uV[
	UTRef<SGScene> scene;
	///	hLgm[h̃X^bN
	FIDocNodes docs;
	///	hLgm[h̍쐬
	virtual UTRef<FIDocNodeBase> CreateDocNode(UTString type, SGObject* o=NULL){
		UTRef<FIDocNodeBase> doc = CreateDocNodeImp(type);
		if (o){
			doc->SetName(o->GetName());
			if (type.compare("REF")!=0) o->doc = doc;
		}
		return doc;
	}
	///	V[Ot̓̃m[hȉZ[u
	virtual void Save(FIDocNodeBase* doc, SGScene* s, SGObject* obj=NULL);
	///	Save̍ċA
	virtual void SaveRecursive(SGObject* obj);
	///	QƂZ[u
	virtual void SaveReference(SGObject* obj);
	
	///	̌^̃Z[o[o^
	void Register(FIBaseSaver* s){ savers.insert(s); }
};

#define DEF_REGISTER_LOADER(cls)				\
void RegisterLoaderFor##cls(FILoadScene* l){	\
	static cls##Loader load_##cls;				\
	l->Register(&load_##cls);					\
}

#define DEF_REGISTER_SAVER(cls)				\
void RegisterSaverFor##cls(FISaveScene* s){	\
	static cls##Saver save_##cls;			\
	s->Register(&save_##cls);				\
}

#define DEF_REGISTER_BOTH(cls)	DEF_REGISTER_SAVER(cls)	DEF_REGISTER_LOADER(cls)

#define REGISTER_LOADER(l, cls)									\
	extern void RegisterLoaderFor##cls(FILoadScene* ld);		\
	RegisterLoaderFor##cls(l);									\

#define REGISTER_SAVER(s, cls)									\
	extern void RegisterSaverFor##cls(FISaveScene* sv);			\
	RegisterSaverFor##cls(s);									\

}
#endif
