#ifndef FIDOCUMENT_H
#define FIDOCUMENT_H

#include "FITypeDesc.h"
#include <Base/BaseUtility.h>
#include <set>
#include <map>
#include <algorithm>

namespace Spr {;

///	̌^
typedef std::string FIString;
///	0̕
extern FIString zeroLengthString;
///	̔r
struct FIStringLess{
	bool operator() (const FIString& s1, const FIString& s2) const { return s1.compare(s2) < 0;}
};
///	̕\
inline std::ostream& operator << (std::ostream& os, FIString s){
	os << s.c_str();
	return os;
}

/**	hLgm[h̓ǂݏoE݈ʒuێReLXg	*/
class FIDocNodePos{
public:
	virtual ~FIDocNodePos(){}
};
/**	t@Co̓m[hD
	V[Ott@C烍[hCt@CɃZ[uۂɁC
	t@C𒼐ڈ킸ɁChLgIuWFNgăZ[uE
	[hƁCt@C̈hLgIuWFNgɔC
	Ƃł̂ŁCZ[uE[h̃R[h炷ƂłD
	̃NX́ChLgIuWFNg\m[h̊{NX.
*/
class SPR_DLL FIDocNodeBase:public UTRefCount{
public:
	friend class FISaveScene;
	///	zfXgN^p
	virtual ~FIDocNodeBase(){}
	//@name	m[h̑
	//@{
	///	̃m[h̖O̎擾
	virtual UTString GetName()=0;
	///	̃m[h̖O̐ݒ
	virtual void SetName(UTString s)=0;
	///	̃m[ȟ^̎擾
	virtual UTString GetType()=0;
	///	̃m[ȟ^̐ݒ
	virtual void SetType(UTString t){}
	///	̃m[ȟ^f[^̎擾
	virtual FITypeDesc* GetTypeDesc()=0;
	///	̃m[hV[Ot̑̃m[hւ̎QƂǂ
	virtual bool IsReference() = 0;
	//@}
	
	//@name	؍\̑
	//@{
	///	em[h
	virtual FIDocNodeBase* GetParent()=0;
	///	qm[h̐
	virtual int NChildren() const =0;
	///	qm[h
	virtual FIDocNodeBase* GetChild(int i){ return Child(i); }
	///	qm[h(Const)
	virtual const FIDocNodeBase* GetChild(int i) const { return ((FIDocNodeBase*)this)->Child(i); }
	///	qm[h̒ǉ
	virtual void AddChild(FIDocNodeBase* n){ n->SetParent(this); }
	///	em[h̐ݒ
	virtual void SetParent(FIDocNodeBase*)=0;
	///	qm[hׂč폜
	virtual void ClearChildren()=0;
	///	qm[h^Ō
	virtual FIDocNodeBase* FindChild(UTString type)=0;
	//@}

	///	f[^ݒ
	virtual void SetDataImp(const void* data, size_t sz);
	///	f[^擾
	virtual void GetDataImp(void* data, int sz, FIString id);
	virtual void GetDataImp(void* data, int sz){ GetDataImp(data, sz,""); }
	///	f[^ݒ(ev[g)
	template <class T> void SetData(const T& t){ SetDataImp(&t, sizeof(t)); }
	///	f[^擾(ev[g)
	template <class T> void GetData(T& t){ GetDataImp(&t, sizeof(t), ""); }
	template <class T> void GetData(T& t, UTString id){ GetDataImp(&t, sizeof(t), id); }
	///	ǂݏoReLXg̍쐬
protected:
	virtual FIDocNodePos* ReadContextImp(FIString id)=0;
public:
	FIDocNodePos* ReadContext(){ return ReadContextImp(""); }
	FIDocNodePos* ReadContext(FIString id){ return ReadContextImp(id); }
	///	݃ReLXg̍쐬
protected:
	virtual FIDocNodePos* WriteContextImp(FIString id){ return ReadContext(id); }
public:
	FIDocNodePos* WriteContext(FIString id){ return WriteContextImp(id); }
	FIDocNodePos* WriteContext(){ return WriteContextImp(""); }
	///	ReLXg̊J
	virtual void ReleaseContext(FIDocNodePos* c){ delete c; }
	///	̃tB[hǂݏo֐
	virtual bool Read(FIDocNodePos* ctx, char* ptr, int sz)=0;
	///	̃tB[h̃f[^	
	virtual void Write(FIDocNodePos* ctx, const char* ptr, int sz, FIString fn, FIString type)=0;
	///	tB[h̃O[vɓ		
	virtual void EnterGroup(FIString fn){}
	///	O[v甲D				
	virtual void ExitGroup(){}
	
	///	m[h̃c[\
	virtual void Print(std::ostream& os, int indent=0) const;
	///	qm[h̃c[\
	virtual void PrintChildren(std::ostream& os, int indent=0) const;
protected:
	///	qm[hԂ֐̎
	virtual FIDocNodeBase* Child(int i) = 0;
};

///	hLgm[h̊{NXvector
class SPR_DLL FIDocNodes:public UTStack< UTRef<FIDocNodeBase> >{
public:
	virtual void Print(std::ostream& os, int indent=0) const;
};

///	hLgm[h
class SPR_DLL FIDocNode:public FIDocNodeBase, public UTTreeNode<FIDocNode>{
	UTString name;
	UTRef<FITypeDesc> typeDesc;
	bool bReference;
	std::vector<char> data;
public:
	typedef UTTreeNode<FIDocNode> Tree;
	///
	FIDocNode(): bReference(false){}
	///
	~FIDocNode(){}
	///	^̐ݒ
	void SetType(FITypeDesc* t);
	void SetType(FIString s){ FIDocNodeBase::SetType(s); }
	//@name	m[h̑
	//@{
	///	̃m[h̖O̎擾
	virtual UTString GetName(){ return name; }
	///	̃m[h̖O̐ݒ
	virtual void SetName(UTString s){ name = s; }
	///	̃m[ȟ^̎擾
	virtual UTString GetType();
	///	̃m[ȟ^f[^̎擾
	virtual FITypeDesc* GetTypeDesc(){ return typeDesc; }
	///	̃m[hV[Ot̑̃m[hւ̎QƂǂ
	virtual bool IsReference(){ return bReference; }
	//@}
	
	//@name	؍\̑
	//@{
	///	em[h
	virtual FIDocNodeBase* GetParent(){ return Tree::GetParent(); }
	///	qm[h̐
	virtual int NChildren() const { return (int)Tree::Children().size(); }
	///	em[h̐ݒ
	virtual void SetParent(FIDocNodeBase* n){ Tree::SetParent((FIDocNode*)n); }
	///	qm[hׂč폜
	virtual void ClearChildren(){ Tree::ClearChildren(); }
	///	qm[h^Ō
	virtual FIDocNodeBase* FindChild(UTString type);
	//@}

	///	ǂݏoReLXg̍쐬
	virtual FIDocNodePos* ReadContextImp(FIString id);
	///	̃tB[hǂݏo֐
	virtual bool Read(FIDocNodePos* ctx, char* ptr, int sz);
	///	̃tB[h̃f[^	
	virtual void Write(FIDocNodePos* ctxBase, const char* ptr, int sz, FIString fn, FIString type);

protected:
	///	qm[hԂ֐̎
	virtual FIDocNodeBase* Child(int i){ return Tree::Children()[i]; }
};

/**	hLgƃt@C̕ϊ̂߂̃ReLXgD	*/
class SPR_DLL FIFileDoc:public UTRefCount{
protected:
	///	t@C
	UTString fileName;
	///	hLgm[h̃X^bN
	FIDocNodes docs;
public:
	///	t@ChLgIuWFNg쐬
	virtual bool Load(UTString filename)=0;
	///	hLgIuWFNgɕۑ
	virtual bool Save(UTString filename, FIDocNodeBase* doc)=0;
	///	hLg̃[gm[h
	virtual FIDocNodes& GetRoots(){ return docs; }
	///	t@C
	UTString GetFileName(){ return fileName; }
};

}
#endif
