#pragma once

#include <Physics/PHSolid.h>
#include <Physics/PHJoint.h>
#include <Physics/PHContactEngine.h>

namespace Spr{;
//JugVRg[
//F̃RrA
/*
	(Ҋ֐Yaw, Ҋ֐Pitch, G֐) = (q1, q2, q3)
	(ڒ, ) = (l1, l2)
	J = {
		-c1(l1c2 + l2c(2-3))	 s1(l1s2 + l2s(2-3))	-l2s1s(2-3)
		-s1(l1c2 + l2c(2-3))	-c1(l1s2 + l2s(2-3))	 l2c1s(2-3)
		0							l1c2 + l2c(2-3)		-l2c(2-3)
	}
	det(J) = -l1l2(l1c2 + l2c(2-3))s3
	ci := cos(qi), si := sin(qi)
*/
enum {LEFT, RIGHT};
enum {FRONT, MIDDLE, BACK};
enum {YAW, PITCH, KNEE, HAND};
enum PHBeetleState{STOP, NEUTRAL, FORWARD, BACKWARD, LEFTTURN, RIGHTTURN};
	
class PHBeetle:public SGBehaviorEngine{
SGOBJECTDEF(PHBeetle);
public:
	class Leg{
		Spr::Vec3f	Error, ErrorInt, ErrorDiff;
	public:
		//݌vp[^
		float		fLength[2];			//ڂ̒
		float		fTilt;				//`gp
		Spr::Vec3f	v3BasePosition;		//x[Xʒui{fBt[j
		Spr::Vec3f	v3ToePosition;		//j[ĝܐʒui{fBt[j
		Spr::Vec3f	v3DesiredPosition;	//ܐڕWʒu
		float		fDirection;			//{fBSܐւ̕ʊp
		float		fDistance;			//{fBSܐւ̋

		PHBeetle*		pBody;				//̂ւ̎Q
		Spr::PHJoint* pJoint[4];		//֐
		
		void Reset();
		void SetPosition(const Spr::Vec3f& pos);
		void Step(double dt);
		Leg(){}
		~Leg(){}
	};

	bool	bReady;

	//݌vp[^
	float	fPValue, fIValue, fDValue;	//PIDW
	float	fStride;					//
	float	fTurnAngle;					//񎞂̋r̐Up
	float	fClearance;					//rグ
	float	fSpeed;						//Hł̑̑x
	float	fSwingBackRate;				//Hx/Hx

	//AAr
	Spr::PHJoint *pjntNeck[2];
	Spr::PHJoint *pjntTail;
	Leg Legs[2][3];
	UTRef<PHContactEngine> contactEngine;

	//s
	PHBeetleState	nState;
	int		nNeutralStep;
	float	fCounter;
	
	///	hLg̃[hCQƂƂŌĂяoD
	virtual void Loaded(SGScene* scene);
	void SetState(PHBeetleState);
	void Step(SGScene* s);
	void CheckForce();
	PHBeetle(void);
	~PHBeetle(void);
};

DEF_RECORD(XBeetle,{
	GUID Guid(){ return WBGuid("2987404D-A7E5-4446-B600-384320589788"); }
});

class PHBeetleLoader : public FIObjectLoader<PHBeetle>
{
public:
	PHBeetleLoader(){
		UTRef<FITypeDescDb> db = new FITypeDescDb;
		db->SetPrefix("X");
		db->REG_RECORD_PROTO(XBeetle);
	}
	bool LoadData(FILoadScene* ctx, PHBeetle* jc){		
		ctx->docs.Top()->GetWholeData(*(XBeetle*)jc);
		return true;
	}
};

class PHBeetleSaver : public FIObjectSaver<PHBeetle>
{
protected:
	void SaveData(class FISaveScene* ctx, FIDocNodeBase* doc, PHBeetle* b){
	}
};

DEF_REGISTER_BOTH(PHBeetle);


}	//	end namespace Spr