#ifndef PH_JOINT_H
#define PH_JOINT_H

#include <Base/BaseUtility.h>
#include <Base/TinyVec.h>
#include <Base/TinyMat.h>
#include <FileIO/FIDocScene.h>
#include <SceneGraph/SGScene.h>
#include <Physics/PHSolid.h>
#include <WinBasis/WBPreciseTimer.h>

///////////////////////////////////////////////////////////////////////////
//RǍn
//F
//FeatherstonẽASY𗘗păc[ɘAꂽ̂
//^V~[gNX

//JӔCҁFcE tazaki@cyb.mei.titech.ac.jp

//QlF"Impulse-based Dynamic Simulation of Rigid Body Systems" Brian Mirtich 1996

namespace Spr{;

//֐߂̎
enum PHJointType{
	TYPE_HINGE,			//]
	TYPE_SLIDER,		//
	//TYPE_BALLJOINT,	//{[WCg
};

//͂̎
enum PHInputType{
	TYPE_TORQUE,		//gN
	TYPE_ACCEL,			//x
	TYPE_VELOCITY,		//x
	TYPE_POSITION		//ʒu
};

//
//enum PHJointControlState{
//	STAT_ACCEL,		//
//	STAT_CRUISE,	//q
//	STAT_DECCEL,	//
//	STAT_HOLD		//ێ
//};

//֐߃t[̐
//	֐߂̈ʒuƌX\邽߂̃t[B
//	֐߃t[_͊֐ߎ̈ʒu\B
//	]֐(TYPE_HINGE)̏ꍇA
//		t[̂y]̌\B
//	m3fRotationParent =: pRj
//	m3fRotationChild  =: cRj
//  fPosition =: q
//	ƂƁA
//	qm[hem[hւ̉]ΐA
//		pRc = pRj * Rot(q, 'z') * cRj.trans()
//	֐(TYPE_SLIDER)̏ꍇA
//		t[̂y̌\B


//SetInfoŎwłtO
enum PHJointInfoEntry{
	INFO_JOINTTYPE,			//֐߂̎
	INFO_POSITIONPARENT,	//em[h猩֐߃t[̈ʒuEp
	INFO_ROTATIONPARENT,
	INFO_POSITIONCHILD,		//qm[h猩֐߃t[̈ʒuEp
	INFO_ROTATIONCHILD,
	INFO_MAXTORQUE,			//őgN
	INFO_MINPOSITION,		//͈
	INFO_MAXPOSITION,
	INFO_INPUTTYPE,			//͂̎
	INFO_INPUT,				//͒l
	INFO_PVALUE,			//PIDp[^
	INFO_IVALUE,
	INFO_DVALUE,
	INFO_SOLID				//SetInfo(INFO_SOLID)Ƃ邱ƂPHSolid̎ʂȂǂ̏ǂݍݒ
};

///֐ߏD̂܂܃t@CJoint^ÕGgƓ
struct PHJointInfo{
	DWORD		nType;				///<	֐ߎ @see PHJointType
	Vec3f		v3fPositionParent;	///<	ễt[猩֐߈ʒu
	Matrix3f	m3fRotationParent;	///<	ễt[猩֐ߎp
	Vec3f		v3fPositionChild;	///<	q̂̃t[猩֐߈ʒu
	Matrix3f	m3fRotationChild;	///<	q̂̃t[猩֐ߎp

	float		fPosition;			///<	ψ
	float		fVelocity;			///<	x
	float		fMaxTorque;			///<	őgN
	float		fMinPosition;		///<	͈(ől)
	float		fMaxPosition;		///<	͈(ŏl)
	DWORD		nInputType;			///<	͂̎ @see PHJointInputType
	float		fInput;				///<	͒l̏l
	float		fPValue;			///<	PIDP̒l
	float		fIValue;			///<	PIDI̒l
	float		fDValue;			///<	PIDD̒l
};

//////////////////////////////////////////////////////////////////////////////////
///	Featherstone's method Ŏg"spatial matrix/vector"
typedef PTM::TVector<6, double> SpVec3d;
typedef PTM::TSubVector<3, SpVec3d::desc> SpSubVec3d;
typedef PTM::TMatrixCol<6, 6, double> SpMatrix3d;
typedef PTM::TSubMatrixCol<3, 3, SpMatrix3d::desc> SpSubMatrix3d;
///	vfANZX
inline SpSubVec3d& svitem(SpVec3d& v, int i){
	return *(SpSubVec3d*)((double*)&v + i*3);
}
inline SpSubMatrix3d& smitem(SpMatrix3d& m, int i, int j){
	return m.sub_matrix(i * 3, j * 3, PTM::TMatDim<3, 3>());
}
///	Ǝ̓ϒ`(v1^T * v2)
inline double svdot(const SpVec3d& v1, const SpVec3d& v2){
	return 
		v1[0] * v2[3] + v1[1] * v2[4] + v1[2] * v2[5] + 
		v1[3] * v2[0] + v1[4] * v2[1] + v1[5] * v2[2];
}
///	v1 * v2^T œs
inline Matrix3d mat(const Vec3d& v1, const Vec3d& v2){
	return Matrix3d(
		v1[0] * v2[0], v1[0] * v2[1], v1[0] * v2[2],
		v1[1] * v2[0], v1[1] * v2[1], v1[1] * v2[2],
		v1[2] * v2[0], v1[2] * v2[1], v1[2] * v2[2]);
}
inline SpMatrix3d svmat(const SpVec3d& v1, const SpVec3d& v2){
    PTM::TVecDim<3> dim3;
	const SpSubVec3d& v11 = v1.sub_vector(0, dim3), v12 = v1.sub_vector(3, PTM::TVecDim<3>());
	const SpSubVec3d& v21 = v2.sub_vector(0, dim3), v22 = v2.sub_vector(3, PTM::TVecDim<3>());
	SpMatrix3d y;
	y.sub_matrix(0, 0, PTM::TMatDim<3, 3>()) = mat(v11, v22);
	y.sub_matrix(0, 3, PTM::TMatDim<3, 3>()) = mat(v11, v21);
	y.sub_matrix(3, 0, PTM::TMatDim<3, 3>()) = mat(v12, v22);
	y.sub_matrix(3, 3, PTM::TMatDim<3, 3>()) = mat(v12, v21);
	return y;
}
/*
///OωZƓȍs(w ~ r == -crossmat(r) * w)
inline Matrix3d crossmat(const Vec3d& r){
	return Matrix3d(
			0, -r[2],  r[1],
		 r[2],     0, -r[0],
		-r[1],  r[0],     0);
}
*/

class PHJoint;
///	֐߂̎ނɂĈقȂvZ
class PHJointCalcBase:public UTRefCount{
public:
	PHJoint* joint;
	PHJointCalcBase():joint(NULL){}			///<	RXgN^
	virtual	void CompJointAxis(){}			///<	֐ߎvZ
	virtual void CompRelativePosition(){}	///<	ΈʒuvZ
	virtual void CompRelativeVelocity(){}	///<	ΑxvZ
	virtual	void CompCoriolisAccel(){}		///<	RIxvZ		
};

///	PHJoint
class PHJoint : public UTTreeNode<PHJoint>, public SGObject{
	friend class PHJointSaver;
	typedef std::vector<UTRef<PHJoint> > array_type;

	//pϐ
	double	error, error_diff, error_int;	///<	덷
	double	accel, torque;					///<	֐߉xAgN
	
	void	CompTorque(double dt);			///<	gŇvZ
	void	PropagateState();				///<	ʒuEx̓`diċA֐j	
	//Featherstone's algorithm
	void	CompArticulatedInertia(double dt);	///<	articulated inertia & ZA-force
	void	Integrate(double dt);				///<	forward dynamics
	
public:
	///	֐ߏ
	PHJointInfo	info;
	///	֐߂̎ނɈˑvZ
	UTRef<PHJointCalcBase> jointCalc;
	
	//Fc := child frame
	//Fp := parent frame
	//Fj := joint frame
	Matrix3d		R;					//orientation matrix
	Quaterniond		quat;				//orientation quaternion
	Vec3d			p;					//position vector
	Matrix3d		pRj, cRj, pRc, cRp;	//rotation matrix(Fp to Fj, Fj to Fc, Fp to Fc, Fc to Fp)
	Vec3d			prc, prj, crj;		//radius vector(Fp to Fc in Fc, Fp to Fj in Fp, Fc to Fj in Fc)
	Vec3d			v, v_abs;			//velocity in Fc/world coord.
	Vec3d			w, w_abs;			//angular velocity in Fc/world coord.
	Vec3d			pvc, pwc;			//[angular]velocity relative to Fp in Fc coord. 
	double			m;					//mass
	Matrix3d		I;					//inertia matrix
	SpMatrix3d		Ii;					//spatial isolated inertia
	SpMatrix3d		Ia;					//spatial articulated inertia
	SpVec3d			Za;					//zero accelaration force in Fc coord.
	SpVec3d			c;					//Coriolis vector in Fc coord.
	SpVec3d			a;					//spatial accelaration in Fc coord.
	SpVec3d			s;					//spatial joint axis in Fc coord.
	
	//LbVϐ
	SpMatrix3d		smat;
	SpVec3d			a_p, Ia_s, Ia_c, Z_plus_Ia_c;
	double			dot_s_Ia_s, dot_s_Z_plus_Ia_c;
	Matrix3d		rcross, rpcross, rcross_cRp, rpcross_pRc;
	
	inline SpMatrix3d pXc_Mat_cXp(SpMatrix3d& m);
	inline SpVec3d	pXc_Vec(SpVec3d& v);
	inline SpVec3d cXp_Vec(SpVec3d& v);
	
	void CompJointAxis(){ jointCalc->CompJointAxis(); }
	void CompRelativePosition(){ jointCalc->CompRelativePosition(); }
	void CompRelativeVelocity(){ jointCalc->CompRelativeVelocity(); }
	void CompCoriolisAccel(){ jointCalc->CompCoriolisAccel(); }	
public:
	SGOBJECTDEF(PHJoint);
	void Loaded(SGScene* scene);

	UTRef<PHSolid> solid;	//qm[hłSolid
	UTRef<SGFrame> frame;	//[gm[hnon-physicalȏꍇFrame
	
	//Zbg
	void	Reset();
	
	//֐ߏ̎擾/ݒ
	PHJointInfo& GetInfo(){return info;}
	const PHJointInfo& GetInfo() const {return info;}
	void SetInfo(PHJointInfoEntry entry, bool recursive = false, void* value = 0);
	float GetPosition(){ return info.fPosition; }
	float GetVelocity(){ return info.fVelocity; }

	//w肵PHSolidQƂĂm[h
	PHJoint* Search(PHSolid*);
	//m[hԂ
	int NumNodes();
	//WCg̑Ԃ
	int NumJoints();

	//
	void Dynamics(double dt);

	//
	void SetPosition(double pos);	//PIDňʒu
	void SetVelocity(double vel);	//PIDőx
	void SetAccel(double accel);	//vZgN@ŉx
	void SetTorque(double torque);	//gNڎw
	double GetTorque(){ return torque; }

	//[gm[hpRXgN^
	PHJoint();					//
	PHJoint(PHSolid* solid);	//physical
	PHJoint(SGFrame* frame);	//non-physical
	//ʃm[hpRXgN^
	PHJoint(PHSolid* solid, const PHJointInfo& info);

	///	LĂIuWFNg̐
	virtual size_t NChildObjects();
	///	LĂIuWFNg
	virtual SGObject* ChildObject(size_t i);
	///	QƂĂIuWFNg̐
	virtual size_t NReferenceObjects();
	///	QƂĂIuWFNg
	virtual SGObject* ReferenceObject(size_t i);
	///	qIuWFNg̒ǉ
	virtual bool AddChildObject(SGObject* o, SGScene* s);
	///	qIuWFNg̍폜
	virtual bool DelChildObject(SGObject* o, SGScene* s);
	///	qɂȂ肦IuWFNǧ^̔z
	virtual const UTTypeInfo** ChildCandidates();

	///	Ԃ̓ǂݏo
	virtual void LoadState(const SGBehaviorStates& states);
	///	Ԃ̕ۑ
	virtual void SaveState(SGBehaviorStates& states) const;
};

SpMatrix3d PHJoint::pXc_Mat_cXp(SpMatrix3d& m){
	static Matrix3d pRc_m11_cRp, pRc_m12_cRp, pRc_m21_cRp, pRc_m22_cRp, tmp;
	pRc_m11_cRp = pRc * smitem(m, 0, 0) * cRp;
	pRc_m12_cRp = pRc * smitem(m, 0, 1) * cRp;
	pRc_m21_cRp = pRc * smitem(m, 1, 0) * cRp;
	pRc_m22_cRp = pRc * smitem(m, 1, 1) * cRp;
	tmp = pRc_m11_cRp - pRc * smitem(m, 0, 1) * rcross_cRp;
	SpMatrix3d	y;
	smitem(y, 0, 0) = tmp;
	smitem(y, 0, 1) = pRc_m12_cRp;
	smitem(y, 1, 0) = rpcross * tmp + pRc_m21_cRp - pRc * smitem(m, 1, 1) * rcross_cRp;
	smitem(y, 1, 1) = rpcross * pRc_m12_cRp + pRc_m22_cRp;
	return y;
}

SpVec3d	PHJoint::pXc_Vec(SpVec3d& v){
	Vec3d pRc_v1 = pRc * svitem(v, 0);
	SpVec3d y;
	svitem(y, 0) = pRc_v1;
	svitem(y, 1) = rpcross * pRc_v1 + pRc * svitem(v, 1);
	return y;
}

SpVec3d PHJoint::cXp_Vec(SpVec3d& v){
	Vec3d cRp_v1 = cRp * svitem(v, 0);
	SpVec3d y;
	svitem(y, 0) = cRp_v1;
	svitem(y, 1) = -rcross * cRp_v1 + cRp * svitem(v, 1);
	return y;
}

//////////////////////////////////////////////////////////////////////////////
//PHJointhNX

class PHJointCalcSlider : public PHJointCalcBase
{
	void CompJointAxis();
	void CompRelativePosition();
	void CompRelativeVelocity();
	void CompCoriolisAccel();
};

class PHJointCalcHinge : public PHJointCalcBase
{
	void CompJointAxis();
	void CompRelativePosition();
	void CompRelativeVelocity();
	void CompCoriolisAccel();
};
	
//////////////////////////////////////////////////////////////////////
//PHJointEngine

class PHJointEngine	: public SGBehaviorEngine
{
public:
	SGOBJECTDEF(PHJointEngine);
	UTRef<PHJoint> root;
	//	Featherstone@ɂ鎞Ԃ̌v
	WBPreciseTimer timer;
	
	int GetPriority() const {return SGBP_JOINTENGINE;}
	void Step (SGScene* s);
	void Loaded(SGScene* scene);
	void Clear(SGScene* s){}
	PHJointEngine::PHJointEngine(){}

	///	LĂIuWFNg̐
	virtual size_t NChildObjects();
	///	LĂIuWFNg
	virtual SGObject* ChildObject(size_t i);
	///	qIuWFNg̒ǉ
	virtual bool AddChildObject(SGObject* o, SGScene* s);
	///	qIuWFNg̍폜
	virtual bool DelChildObject(SGObject* o, SGScene* s);
	///	qɂȂ肦IuWFNǧ^̔z
	virtual const UTTypeInfo** ChildCandidates();

	///	Ԃ̓ǂݏo
	virtual void LoadState(const SGBehaviorStates& states);
	///	Ԃ̕ۑ
	virtual void SaveState(SGBehaviorStates& states) const;
};
}

#endif