#ifndef SG_OBJECT_H
#define SG_OBJECT_H

#include <Base/BaseUtility.h>
#include <Base/BaseTypeInfo.h>
#include <Base/Affine.h>
#include <FileIO/FIDocNode.h>
#include <WinBasis/WBWin.h>


namespace Spr {;

///	SGObject pNX̓oƂẴ}ND
#define SGOBJECTDEF(cls)								\
public:													\
	static UTTypeInfoImp<cls> typeInfo;					\
	virtual const UTTypeInfo* GetTypeInfo() const {		\
		return &typeInfo;								\
	}													\
	static const UTTypeInfo* GetTypeInfoStatic(){		\
		return &typeInfo;								\
	}													\

#define SGOBJECTDEFABST(cls)							\
public:													\
	static UTTypeInfoImpAbst<cls> typeInfo;				\
	virtual const UTTypeInfo* GetTypeInfo() const {		\
		return &typeInfo;								\
	}													\
	static const UTTypeInfo* GetTypeInfoStatic(){		\
		return &typeInfo;								\
	}													\


#define SGOBJECTIMPBASE(cls)			DEF_UTTYPEINFO(cls)
#define SGOBJECTIMPBASEABST(cls)		DEF_UTTYPEINFOABST(cls)
#define SGOBJECTIMP(cls, base)			DEF_UTTYPEINFO1(cls, base)
#define SGOBJECTIMPABST(cls, base)		DEF_UTTYPEINFOABST1(cls, base)

class SGScene;

/**	V[Ot̃IuWFNg^D
	NXԂ֐D	*/
class SPR_DLL SGObject:public UTRefCount{
	///	O
	UTString name;
protected:
	friend class SGObjectNames;
public:
	///	NX̎擾Ȃǂ̊{@\̎
	SGOBJECTDEF(SGObject);
	///	̃IuWFNǧƂȂhLg
	UTRef<FIDocNodeBase> doc;
	///	[URɎg|C^
	void* userData;

	///
	SGObject(): userData(NULL) {}
	///	fXgN^virtual
	virtual ~SGObject();

	///	O̎擾
	const char* GetName() const { return name.c_str(); }
	///	O̐ݒ
	void SetName(const char* n, SGScene* s);
	///	֘AtꂽhLgm[hJ
	virtual void ReleaseDoc(){ doc = NULL; }

	///	hLg̃[hCQƂƂŌĂяoD
	virtual void Loaded(SGScene* scene){}
	///	fobOp̕\
	virtual void Print(std::ostream& os) const;

	///	LĂIuWFNg̐
	virtual size_t NChildObjects(){ return 0; }
	///	LĂIuWFNg
	virtual SGObject* ChildObject(size_t i){ return NULL; }
	///	QƂĂIuWFNg̐
	virtual size_t NReferenceObjects(){ return 0; }
	///	QƂĂIuWFNg
	virtual SGObject* ReferenceObject(size_t i){ return NULL; };
	///	qIuWFNg̒ǉ(LEQƂȂ)
	virtual bool AddChildObject(SGObject* o, SGScene* s){ return false; }
	///	qIuWFNg̍폜
	virtual bool DelChildObject(SGObject* o, SGScene* s){ return false; }
	///	qɂȂ肦IuWFNǧ^̔z
	virtual const UTTypeInfo** ChildCandidates();
};

///	SGObject̃|C^̔z
class SGObjects:public UTStack< UTRef<SGObject> >{
public:
	///	T̔hNXX^bNTopTD
	template <class T> bool Find(T*& t){
		for(iterator it = end(); it != begin();){
			--it;
			T* tmp = DCAST(T, *it);
			if (tmp){
				t = tmp;
				return true;
			}
		}
		return false;
	}
};

}
#endif SG_OBJECT_H
